/*added for kinematicCloud*/
Info<< "\nReading transportProperties\n" << endl;
    IOdictionary transportProperties
    (
        IOobject
        (
            "transportProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ_IF_MODIFIED,
            IOobject::NO_WRITE
        )
    );



    Info<< "Reading field p_rgh\n" << endl;
    volScalarField p_rgh
    (
        IOobject
        (
            "p_rgh",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );
    


    Info<< "Reading field U\n" << endl;
    volVectorField U
    (
        IOobject
        (
            "U",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );

    #include "createPhi.H"

   immiscibleIncompressibleThreePhaseMixture mixture(U, phi); // threePhaseMixture threePhaseProperties(U, phi); // updated from 2.3
volScalarField& alpha1(mixture.alpha1()); // updated from 2.3
volScalarField& alpha2(mixture.alpha2()); // updated from 2.3
volScalarField& alpha3(mixture.alpha3()); // updated from 2.3
    alpha1 == 1.0 - alpha2 - alpha3;

const dimensionedScalar& rho1 = mixture.rho1();
const dimensionedScalar& rho2 = mixture.rho2();
const dimensionedScalar& rho3 = mixture.rho3();
const dimensionedScalar& rhoS_ = mixture.lookup("rhoS");
const dimensionedScalar& dS_ = mixture.lookup("dS");

dimensionedScalar D23("D23", dimViscosity, mixture);
    
    

    // Need to store rho for ddt(rho, U)
    volScalarField rho
    (
        IOobject
        (
            "rho",
            runTime.timeName(),
            mesh,
            IOobject::READ_IF_PRESENT
        ),
        alpha1*rho1 + alpha2*rho2 + alpha3*rho3,
        alpha1.boundaryField().types()
    );
    rho.oldTime();


    // Mass flux
    // Initialisation does not matter because rhoPhi is reset after the
    // alpha solution before it is used in the U equation.
    surfaceScalarField rhoPhi
    (
        IOobject
        (
            "rho*phi",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        rho1*phi
    );


    // Construct interface from alpha distribution


    // Construct incompressible turbulence model
    autoPtr<incompressible::turbulenceModel> turbulence
    (
        incompressible::turbulenceModel::New(U, phi, mixture) //threePhaseProperties) // updated from 2.3
    );

    

#include "readGravitationalAcceleration.H" // updated from 2.3
#include "readhRef.H" // updated from 2.3
#include "gh.H" // updated from 2.3

    volScalarField p
    (
        IOobject
        (
            "p",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        p_rgh + rho*gh
    );

    label pRefCell = 0;
    scalar pRefValue = 0.0;
    setRefCell
    (
        p,
        p_rgh,
        mesh.solutionDict().subDict("PIMPLE"),
        pRefCell,
        pRefValue
    );

    if (p_rgh.needReference())
    {
        p += dimensionedScalar
        (
            "p",
            p.dimensions(),
            pRefValue - getRefCellValue(p, pRefCell)
        );
        p_rgh = p - rho*gh;
    }



    tmp<surfaceScalarField> tphiAlphaCorr0;
    
    

mesh.setFluxRequired(p_rgh.name()); // updated from 2.3
mesh.setFluxRequired(alpha2.name()); // updated from 2.3

#include "createMRF.H" // updated from 2.3
