{
    volScalarField rAU("rAU", 1.0/UEqn.A());
        surfaceScalarField rAUf("rAUf", fvc::interpolate(rAU));//surfaceScalarField rAUf("Dp", fvc::interpolate(rAU)); // updated from 2.3

    volVectorField HbyA(constrainHbyA(rAU*UEqn.H(), U, p_rgh)); //volVectorField HbyA("HbyA", U); // updated from 2.3
    // HbyA = rAU*UEqn.H(); // updated from 2.3
    Info<<" create phiHbyA"<<endl;
    surfaceScalarField phiHbyA
    (
        "phiHbyA",
        //fvc::flux(HbyA) // updated from 2.3
      (fvc::interpolate(HbyA) & mesh.Sf()) + fvc::interpolate(rho*rAU)*fvc::ddtCorr(U, phi)
  //      (fvc::interpolate(HbyA) & mesh.Sf())
  //    + fvc::interpolate(rho*rAU)*fvc::ddtCorr(U, phi)
    );
    MRF.makeRelative(phiHbyA); // updated from 2.3
    adjustPhi(phiHbyA, U, p_rgh);
    //phi = phiHbyA;

    surfaceScalarField phig
    (
	(
            mixture.surfaceTensionForce() // updated from 2.3
          - ghf*fvc::snGrad(rho)
        )*rAUf*mesh.magSf()
	
        /*(
            fvc::interpolate(interface.sigmaK())*fvc::snGrad(alpha1)
          - ghf*fvc::snGrad(rho)
        )*rAUf*mesh.magSf()
	+ (fvc::interpolate(rAU*cloudVolSUSu) & mesh.Sf()) //fvc::interpolate(rAU*cloudVolSUSu) & mesh.Sf() //drag + pressure gradient force - explicit drag part*/
    );

    phiHbyA += phig;
    
    // Update the pressure BCs to ensure flux consistency
    constrainPressure(p_rgh, U, phiHbyA, rAUf, MRF); // updated from 2.3

  /*      setSnGrad<fixedFluxPressureFvPatchScalarField> // updated from 2.3
    (
        p_rgh.boundaryField(),
        (
            phiHbyA.boundaryField()
          - (mesh.Sf().boundaryField() & U.boundaryField())
        )/(mesh.magSf().boundaryField()*rAUf.boundaryField())
    );*/

    while (pimple.correctNonOrthogonal())
    {
        fvScalarMatrix p_rghEqn
        (
            fvm::laplacian(rAUf, p_rgh) == fvc::div(phiHbyA)
        );

        p_rghEqn.setReference(pRefCell, getRefCellValue(p_rgh, pRefCell));

        p_rghEqn.solve(mesh.solver(p_rgh.select(pimple.finalInnerIter())));

        if (pimple.finalNonOrthogonalIter())
        {
            phi = phiHbyA - p_rghEqn.flux();

	    p_rgh.relax();

            U = HbyA + rAU*fvc::reconstruct((phig - p_rghEqn.flux())/rAUf);
            U.correctBoundaryConditions();
            fvOptions.correct(U);
        }
    }

    #include "continuityErrs.H"

    p == p_rgh + rho*gh;

    if (p_rgh.needReference())
    {
        p += dimensionedScalar
        (
            "p",
            p.dimensions(),
            pRefValue - getRefCellValue(p, pRefCell)
        );
        p_rgh = p - rho*gh;
    }
}

